
#include <project.h>
#include "math.h"


#define DELAY       (0x20u)
#define UP          (0x1u)
#define DOWN        (0x0u)
#define CNT_PULSE   (0x8000u)

uint32 InterruptCnt;



/*******************************************************************************

* Hardware Dependency:
*  Pin Connections:
*  P1[4] --> SineWave output
* 
* Code Tested With:
*  1. PPSoC Creator  1.0 Service Pack 2 (1.0.1.21) 
*  2. DP8051 Keil 8.16
*  3. ARM GCC 4.4.1
*/

//#include <device.h>

const unsigned char SineTable100[] = {
126,126,126,125,124,123,122,120,118,116,114,112,109,106,103,100,97,93,90,86,82,
79,75,71,67,63,59,55,51,47,44,40,36,33,29,26,23,20,17,14,12,10,8,6,4,3,2,1,0,0,
0,0,0,1,2,3,4,6,8,10,12,14,17,20,23,26,29,33,36,40,44,47,51,55,59,63,67,71,75,79,
82,86,90,93,97,100,103,106,109,112,114,116,118,120,122,123,124,125,126,126
};

const unsigned char SineTable128[] = {
254,254,253,253,252,250,249,247,244,242,239,236,233,229,225,221,217,212,208,203,
198,192,187,181,176,170,164,158,152,146,139,133,127,121,115,108,102,96,90,84,78,
73,67,62,56,51,46,42,37,33,29,25,21,18,15,12,10,7,5,4,2,1,1,0,0,0,1,1,2,4,5,7,10,
12,15,18,21,25,29,33,37,42,46,51,56,62,67,73,78,84,90,96,102,108,115,121,127,133,
139,146,152,158,164,170,176,181,187,192,198,203,208,212,217,221,225,229,233,236,
239,242,244,247,249,250,252,253,253,254
};

unsigned char Pointer=0,Pointer2=0;   // Variable to hold the index into the lookup table
int16 test;
 
CY_ISR(ISR_1_Int) {
    uint32 source;
    IDAC_1_SetValue(SineTable128[Pointer]);
    Pointer++;
    if (Pointer >= 128) {
		//Pin_Out1_Write(~Pin_Out1_Read());// Rechtecksignal
        Pointer = 0;
		test++;
		if(test==200){
			LED_1_6_Write(~LED_1_6_Read());// LED toggeln
			test=0;
		}		
    }
   Timer_1_ReadStatusRegister();//Interrupt zurücksetzen
    
}
 
CY_ISR(ISR_2_Int) {
    uint32 source;
    
    IDAC_2_SetValue(SineTable100[Pointer2]);
    Pointer2++;
    if (Pointer2 >= 100) {
        Pointer2 = 0;
    }
 	Timer_2_ReadStatusRegister();
}


static char deziwert[9]={'0','0','0','.','0','0','0',' ',0x00};
uint8 ziffer,zahl;
uint32 dez;
uint8 index1;

void PrintChar(char numb1){
zahl=numb1;
index1=4;
ziffer = 0;
while (zahl >= 100){//Hunderterstelle gesondert behandeln
	zahl = zahl-100;
	ziffer++;
	}
deziwert[index1]= ziffer+'0';
index1++;
while(index1<7){
	ziffer = 0;
	while (zahl >= 10){
		zahl = zahl-10;
		ziffer++;
		}
	deziwert[index1]= ziffer+'0';
	zahl=zahl * 10;
	index1++;
	}	
LCD_1_PrintString(&deziwert[4]);
}


void PrintInteger(numb,col,row){
int16 numm;
numm=numb;
index1=1;
LCD_1_Position(col, row);
ziffer = 0;
while (numm >= 10000){//10000er gesondert behandeln
	numm = numm-10000;
	ziffer++;
	}
if(deziwert[index1] =='.') index1++;
deziwert[index1]= ziffer+'0';
index1++;
while(index1<7){
	ziffer = 0;
	while (numm >= 1000){
		numm = numm-1000;
		ziffer++;
		}
	if(deziwert[index1] =='.') index1++;
	deziwert[index1]= ziffer+'0';				
	numm=10*numm;
	//numm=numm<<1;
	//numm=numm+(numm<<3);//numm * 10
	index1++;
	}	
LCD_1_PrintString(&deziwert[1]);
}
int8 menue=0;
 int8  encoder1,encoderOld1=50,diff;

int GetEncoder(){
encoder1=(int8)QuadDec_1_ReadCounter();	//Abfrage Dreh- Encoder 1
if(encoder1!=encoderOld1){ 
	diff=encoder1-encoderOld1;	//Abfrage Dreh- Encoder 1;
    encoderOld1=encoder1=50;
	QuadDec_1_WriteCounter(50);
	return diff;
    }
return 0;  
}


int main()
{
int16 frequ,freq1;
int32 div,help;
uint8 div2;
int16 i;
float32 z;
	
	test=0;

	Pointer=0;
	Pointer2=0; 
	ISR_1_StartEx(ISR_1_Int);
	Timer_1_Start();
    ISR_2_StartEx(ISR_2_Int);
	Timer_2_Start();
    IDAC_1_Start();
    IDAC_2_Start();
  	QuadDec_1_Start();
	QuadDec_1_WriteCounter(50);
	QuadDec_1_TriggerCommand(QuadDec_1_MASK, QuadDec_1_CMD_RELOAD);
    CyGlobalIntEnable; // Uncomment this line to enable global interrupts.
   	
	//Opamp_1_Start();
	LCD_1_Start();
	LCD_1_Position(0, 0);
	LCD_1_PrintString("Sinus generator ");
while(1){
    LED_1_6_Write(0);//LED aus
    if(!Button_Read()){
        LED_1_6_Write(1);//LED ein
        if(menue<3) menue++;
        else menue=0;
        CyDelay(1000);        
    }
    else {
        LED_1_6_Write(0);//LED aus	
    }
    switch (menue){
    case 0:{
        LED_1_6_Write(0);//LED aus
		Pointer=0;
		Pointer2=0;
    	ISR_2_StartEx(ISR_2_Int);
		Clock_2_Start();
		IDAC_2_Start();
        LCD_1_Position(0, 0);
        LCD_1_PrintString("2 Tones         ");
		Clock_1_SetDivider((24000000/128)/700);//   700Hz, 128 steps
        Clock_2_SetDivider((24000000/100)/1100);// 1100Hz, 100 steps
        PrintInteger(700,1,2);
        PrintInteger(1100,1,10);       
        while(menue==0){                          
            if(!Button_Read()) {
                menue=1;
                LED_1_6_Write(1);//LED ein
                CyDelay(200);								
				}
			//PrintInteger(test, 0, 10);
            }         
       break; 
        
       }
    case 1:{
		ISR_2_Stop();
        LED_1_6_Write(0);//LED aus
        LCD_1_Position(0, 0);
        LCD_1_PrintString("Sweep           ");
		Pointer=0;
		Clock_2_Stop();
		IDAC_2_Stop();
		
        while(1){
            for(i=3900;i<7501;i++){  //8300
                if(!Button_Read()) {
                    menue=2;
                    LED_1_6_Write(1);//LED ein
                    CyDelay(200);
                    Button_Read();
                }
				z=(float)i/1000;
				frequ=exp(z);
				div=6000000/frequ;
				div2=div%32;	
				div=div>>5;				
                Clock_1_SetFractionalDividerRegister((int16)div, div2);
                if(i%500==0){
					PrintInteger(frequ,1,2);
                	LCD_1_PrintString("        ");
				}
                CyDelayUs(1000);               	
            if(menue!=1) break;     
            }
        if(menue!=1) break;    
        }
      break;  
      }
    case 2:{
        
        char brk=0;
        LED_1_6_Write(0);//LED aus
        LCD_1_Position(2, 0);
        LCD_1_PrintString("1 Tone          ");
		div=187500/1000;
        Clock_1_SetDivider(div);
        PrintInteger(1000,1,2);
        LCD_1_PrintString("        ");
        while(1){
            if(!Button_Read()) {
                menue=3;
                brk=1;
                LED_1_6_Write(1);//LED ein
                CyDelay(200);
                Button_Read();	
                break;
            }
            if(brk) break;
            freq1+=GetEncoder();
			if((4001>freq1)&&(freq1>50)){
                    div=187500/freq1;
                    Clock_1_SetDivider(div);
                    PrintInteger(freq1,1,2); 
                }        
          
        if(brk) break;
        }
        break;
      }
      case 3:{
        freq1=400;
        char brk=0;
		Pointer=0;
		Pointer2=0;
        LED_1_6_Write(0);//LED aus
        LCD_1_Position(0, 0);
        LCD_1_PrintString("1 Tone          ");
		div=187500/400;
        Clock_1_SetDivider(div);
        PrintInteger(400,1,2);
        LCD_1_PrintString("        ");
        while(1){
            if(!Button_Read()) {
                menue=0;
                brk=1;
                LED_1_6_Write(1);//LED ein
                CyDelay(200);
                Button_Read();	
                break;
            }
            if(brk) break;
			
          	freq1+=GetEncoder();
                if((4001>freq1)&&(freq1>50)){
                    div=187500/freq1;
                    Clock_1_SetDivider(div);
                    PrintInteger(freq1,1,2); 
                }        
            
        if(brk) break;
        }
        break;
      }
     } 
    }// Loop forever    
}
/* [] END OF FILE */


